Index: extensions/gally/gally-default/admin/Conf.class.inc.php
===================================================================
--- extensions/gally/gally-default/admin/Conf.class.inc.php	(revision 8191)
+++ extensions/gally/gally-default/admin/Conf.class.inc.php	(revision 8528)
@@ -117,4 +117,9 @@
   }
 
+  public function confExists($key)
+  {
+    return(array_key_exists($key, $this->values));
+  }
+
   public function getConfValue($key)
   {
@@ -144,4 +149,54 @@
 
 
+  /**
+   * function used to initialize config file
+   *
+   */
+  static public function init($theme)
+  {
+    $forcedToDefault=array(
+      "imageCenterMode" => '',
+      "imageCenterOffset" => '',
+      "imageCenterTopMin" => '',
+      "imageCenterTopBorder" => '',
+      "interfaceAnimated" => '',
+      "commentAnimated" => '',
+      "animateDelay" => '',
+      "marginContainer" => '',
+      "paddingContainer" => '',
+      "tabsAnimated" => '',
+      "tabsHidden" => '',
+      "tabsVisible" => '',
+      "tabsPosition" => '',
+      "commentRows" => '',
+      "menuAnimated" => '',
+      "menuWidth" => '',
+      "menuMaxWidth" => '',
+      "menuMSIEMaxWidth" => '',
+      "imageSimulateHighRes" => '',
+      "imageScrollMinDeadArea" => ''
+      //"expandMenu" => '',
+    );
+    $gallyDefault = new Conf();
+    $gallyDefault->setFileName(PHPWG_ROOT_PATH."themes/gally-default/conf/default.conf");
+    $gallyDefault->read();
+
+    $configDefault = new Conf();
+    $configDefault->setFileName(PHPWG_ROOT_PATH."themes/$theme/conf/default.conf");
+    $configDefault->read();
+
+    $configLocal = new Conf();
+    $configLocal->setFileName(PHPWG_ROOT_PATH."local/themes/$theme/conf/local.conf");
+    $configLocal->read();
+
+    foreach($forcedToDefault as $key => $param)
+    {
+      if($gallyDefault->confExists($key)) $forcedToDefault[$key]=$gallyDefault->getConfValue($key);
+      if($configDefault->confExists($key)) $forcedToDefault[$key]=$configDefault->getConfValue($key);
+    }
+    $configLocal->setConf($forcedToDefault, false);
+    $configLocal->write();
+  }
+
 }
 
Index: extensions/gally/gally-default/admin/GallyDefault.class.inc.php
===================================================================
--- extensions/gally/gally-default/admin/GallyDefault.class.inc.php	(revision 8191)
+++ extensions/gally/gally-default/admin/GallyDefault.class.inc.php	(revision 8528)
@@ -20,4 +20,6 @@
 class GallyDefault
 {
+  const THEME_VERSION = '1.4.0';
+
   private $directories=Array(
     'templates.parent' => '',
@@ -32,6 +34,48 @@
   protected $themeProperties = Array(
       'name' => 'Gally/Default',
-      'version' => '1.3.1'
+      'version' => self::THEME_VERSION
     );
+
+
+  /**
+   * function used to activate a theme
+   *
+   * @param String $themeId : theme's id (for example 'gally-lapis-lazulis')
+   * @param String $themeVersion : theme's release (not gally-default release)
+   * @param String $gallyDefaultNeeded : gally-default release needed
+   * @param &Array $errors : array of error messages
+   */
+  static public function activate($themeId, $themeVersion, $gallyDefaultNeeded, $errors)
+  {
+    if(strnatcmp(self::THEME_VERSION, $gallyDefaultNeeded)<0)
+    {
+      if(!is_array($errors))
+      {
+        if($errors!='')
+        {
+          $errors=array($errors);
+        }
+        else
+        {
+          $errors=array();
+        }
+      }
+
+      $errors[]=sprintf(l10n('This theme needs Gally-default theme v%s; actually, Gally-default version is %s.'), $gallyDefaultNeeded, self::THEME_VERSION);
+    }
+    else
+    {
+      Conf::init($themeId);
+    }
+    return($errors);
+  }
+
+  /**
+   * function used to deactivate a theme
+   *
+   */
+  static public function deactivate()
+  {
+  }
 
   /**
@@ -92,5 +136,5 @@
     $this->config->read();
     $this->config->setFileName($this->directories['conf.local']."/default.conf");
-    $this->config->read();
+    $this->config->read(false);
     $this->config->setFileName(PHPWG_ROOT_PATH."local/themes/".basename(dirname($this->directories['conf.local']))."/conf/local.conf");
     $this->config->read(false);
Index: extensions/gally/gally-default/conf/default.conf
===================================================================
--- extensions/gally/gally-default/conf/default.conf	(revision 8191)
+++ extensions/gally/gally-default/conf/default.conf	(revision 8528)
@@ -72,4 +72,8 @@
 imageCenterTopBorder="imageHeaderBar"
 
+# -- 1.4.0 --
+# The 'imageScrollMinDeadArea' option allows to define the minimum width for
+# dead area in scroll mode
+imageScrollMinDeadArea=0
 
 # The 'imageInterface' option can take theses values :
@@ -195,5 +199,18 @@
 highResClickMode="zoom"
 
-
+# -- 1.4.0 --
+# the 'manageTips' option can take theses values :
+#   "yes" => the interface uses the simpleTip.js script to display hints
+#   "no"  => the interface uses the default browser method to display hints
+manageTips="no"
+
+# -- 1.4.0 --
+# the 'manageTipsPos' define the default position for tips ; the option can take
+# theses values :
+#   "tipOnTop"    => tip is displayed above the object
+#   "tipOnBottom" => tip is displayed under the object
+#   "tipOnLeft"   => tip is displayed on the left side of the object
+#   "tipOnRight"  => tip is displayed on the right side of the object
+manageTipsPos="tipOnBottom"
 
 # ------- Menu parameters ------------------------------------------------------
Index: extensions/gally/gally-default/js/gallyjs-tcp.js
===================================================================
--- extensions/gally/gally-default/js/gallyjs-tcp.js	(revision 8191)
+++ extensions/gally/gally-default/js/gallyjs-tcp.js	(revision 8528)
@@ -4,7 +4,7 @@
   ------------------------------------------------------------------------------
   file: gally/gallyjs-tcp.js
-  file release: 1.1.0
+  file release: 1.4.0
   ------------------------------------------------------------------------------
-  author: grum at grum.dnsalias.com
+  author: grum at piwigo.org
   << May the Little SpaceFrog be with you >>
   ------------------------------------------------------------------------------
@@ -16,214 +16,224 @@
 ----------------------------------------------------------------------------- */
 
-var menuState;
-
-$("document").ready( function()
-  {
-    initMenu();
-    initContentDesc();
+var gallyCP=null;
+
+$(document).ready(
+  function()
+  {
+    gallyCP=new GallyCP();
   }
 );
 
 
-function initContentDesc()
+function GallyCP ()
 {
-  if(($("#additional_infoTOP").length + $("#additional_infoBOTTOM").length)<2)
-  {
-    // if div TOP & BOTTOM don't exists, it's not necessary to process this the
-    // initialisation
-    return(false);
-  }
-/*
-  this code permit to manage 3 informations panels with one text area (or 2 if
-  extended description plugin is used)
-
-  this function don't use a regExp object (due to some freeze with this method
-  during test)
-
-  known tags :
-    <!--up-down-->
-    <!--right-left-->
-
-  if the plugin "ExtendedDescription" is installed, the "<!--up-down-->" tag is
-  already managed by the plugin :
-    - top text is in a <div class="additional_info">
-        => text is moved to the to the '#additional_infoTOP' div  and
-            the '.additional_info' div added by the plugin is deleted
-    - bottom text is in <div id="additional_infoLEFT">
-        => if tag "<!--right-left-->" is present
+  var menuState,
+
+  initContentDesc = function()
+  {
+    if(($("#additional_infoTOP").length + $("#additional_infoBOTTOM").length)<2)
+    {
+      // if div TOP & BOTTOM don't exists, it's not necessary to process this the
+      // initialisation
+      return(false);
+    }
+    /*
+      this code permit to manage 3 informations panels with one text area (or 2 if
+      extended description plugin is used)
+
+      this function don't use a regExp object (due to some freeze with this method
+      during test)
+
+      known tags :
+        <!--up-down-->
+        <!--right-left-->
+
+      if the plugin "ExtendedDescription" is installed, the "<!--up-down-->" tag is
+      already managed by the plugin :
+        - top text is in a <div class="additional_info">
+            => text is moved to the to the '#additional_infoTOP' div  and
+                the '.additional_info' div added by the plugin is deleted
+        - bottom text is in <div id="additional_infoLEFT">
+            => if tag "<!--right-left-->" is present
+                text on right is moved to the to the '#additional_infoBOTTOM' div and
+                removed from the '#additional_infoLEFT' div
+
+      if the plugin "ExtendedDescription" is not installed, all the text is in
+      the <div id="additional_infoLEFT">
+        => if tag "<!--up-down-->" is present
+            text on right is moved to the to the '#additional_infoTOP' div and
+            removed from the '#additional_infoLEFT' div
+        => if tag "<!--right-left-->" is present on the '#additional_infoLEFT' div
             text on right is moved to the to the '#additional_infoBOTTOM' div and
             removed from the '#additional_infoLEFT' div
-
-  if the plugin "ExtendedDescription" is not installed, all the text is in
-  the <div id="additional_infoLEFT">
-    => if tag "<!--up-down-->" is present
-        text on right is moved to the to the '#additional_infoTOP' div and
-        removed from the '#additional_infoLEFT' div
-    => if tag "<!--right-left-->" is present on the '#additional_infoLEFT' div
-        text on right is moved to the to the '#additional_infoBOTTOM' div and
-        removed from the '#additional_infoLEFT' div
-*/
-
-  // <!--up-down--> tag
-  txt = $("#additional_infoLEFT").attr("innerHTML");
-  if(txt==null) { txt=""; }
-  tmp = txt.indexOf("<!--up-down-->");
-
-  if(tmp>-1)
-  { // tag is not managed by the ExtendedDescription plugin
-    $("#additional_infoTOP").attr("innerHTML", txt.slice(0,tmp));
-    txt=txt.substr(tmp+14); //remove the tag
-  }
-  else
-  { // perhaps tag is managed by the ExtendedDescription plugin
-    $(".additional_info").each( function (i)
+    */
+
+    // <!--up-down--> tag
+    txt = $("#additional_infoLEFT").attr("innerHTML");
+    if(txt==null) { txt=""; }
+    tmp = txt.indexOf("<!--up-down-->");
+
+    if(tmp>-1)
+    { // tag is not managed by the ExtendedDescription plugin
+      $("#additional_infoTOP").attr("innerHTML", txt.slice(0,tmp));
+      txt=txt.substr(tmp+14); //remove the tag
+    }
+    else
+    { // perhaps tag is managed by the ExtendedDescription plugin
+      $(".additional_info").each( function (i)
+        {
+          if(this.id=="")
+          {
+            $("#additional_infoTOP").attr("innerHTML", $("#additional_infoTOP").attr("innerHTML")+this.innerHTML);
+            this.parentNode.removeChild(this);
+          }
+        }
+      );
+    }
+
+    // <!--right-left--> tag
+    tmp = txt.indexOf("<!--right-left-->");
+
+    if(tmp>-1)
+    { // tag is present, cut the right text to the
+      $("#additional_infoBOTTOM").attr("innerHTML", txt.slice(0,tmp));
+      txt=txt.substr(tmp+17);
+    }
+
+    $("#additional_infoLEFT").attr("innerHTML", txt);
+
+    if((txt.replace(/\s*/im, "")=="")&&($("#additional_infoID").length>0))
+    {
+      // remove the left area if empty
+      $("#additional_infoID").get(0).parentNode.removeChild($("#additional_infoID").get(0));
+    }
+    $(".additional_info").css("visibility", "visible");
+
+    if($("#additional_infoBOTTOM").attr("innerHTML").replace(/\s*/im, "")=="")
+    {
+      // remove the bottom area if empty
+      $("#additional_infoBOTTOM").get(0).parentNode.removeChild($("#additional_infoBOTTOM").get(0));
+    }
+    else
+    {
+      $("#additional_infoBOTTOM").css("visibility", "visible");
+    }
+
+    if($("#additional_infoTOP").attr("innerHTML").replace(/\s*/im, "")=="")
+    {
+      // remove the top area if empty
+      $("#additional_infoTOP").get(0).parentNode.removeChild($("#additional_infoTOP").get(0));
+    }
+    else
+    {
+      $("#additional_infoTOP").css("visibility", "visible");
+    }
+  },
+
+  initMenu = function ()
+  {
+    if(options.menuAnimated != "noswitch")
+    {
+      $("#menubar").css(
+        {
+          visibility:"hidden",
+          top: $("#titrePageID").attr("offsetTop")+$("#titrePageID").attr("offsetHeight")-2+'px'
+        }
+      );
+      switchmenu('n');
+      switch(options.menuWidth)
       {
-        if(this.id=="")
+        case "auto":
+          $("#menubar").css("width", "auto");
+          maxwidth=options.menuMaxWidth;
+
+          regexp = /[1234567]\./i;
+          if(jQuery.browser.msie && jQuery.browser.version.match(regexp))
+          {
+            maxwidth=options.menuMSIEMaxWidth;
+          }
+          if(maxwidth>0) { $("#menubar").css("max-width", maxwidth+"px"); }
+          break;
+        case "info":
+          $("#menubar").css("width", $(".additionnal_info").css("width"));
+          break;
+        default:
+          $("#menubar").css("width", options.menuWidth+"px");
+      }
+    }
+    else
+    {
+      $("#menubar dl dd").each(
+        function (index, elem)
         {
-          $("#additional_infoTOP").attr("innerHTML", $("#additional_infoTOP").attr("innerHTML")+this.innerHTML);
-          this.parentNode.removeChild(this);
+          //alert($(this.parentNode).attr('offsetWidth')+"---"+$(this.parentNode).attr('id'));
+          $(this).css("min-width", $(this.parentNode).attr('offsetWidth'));
+          if(jQuery.browser.msie)
+          {
+            $(this).css("max-width", options.menuMSIEMaxWidth+"px");
+          }
         }
+      );
+    }
+  },
+
+  switchmenu = function(force, iconpath)
+  {
+    if(force=='')
+    {
+      (!menuState)?force='y':force='n';
+    }
+
+    if(options.menuAnimated == "fade")
+    {
+      switch(force)
+      {
+        case 'y':
+          $("#menubar").css({
+            visibility:"visible",
+            height:"auto"
+          }).fadeTo(options.animateDelay,1);
+          $("#icon_menu").attr("className", "button2");
+          menuState=true;
+          break;
+        default:
+          $("#menubar").fadeTo(options.animateDelay, 0, function () {
+            $("#menubar").css({
+              visibility:"hidden",
+              height:"0px"
+            });
+          });
+          $("#icon_menu").attr("className", "button");
+          menuState=false;
       }
-    );
-  }
-
-  // <!--right-left--> tag
-  tmp = txt.indexOf("<!--right-left-->");
-
-  if(tmp>-1)
-  { // tag is present, cut the right text to the
-    $("#additional_infoBOTTOM").attr("innerHTML", txt.slice(0,tmp));
-    txt=txt.substr(tmp+17);
-  }
-
-  $("#additional_infoLEFT").attr("innerHTML", txt);
-
-  if((txt.replace(/\s*/im, "")=="")&&($("#additional_infoID").length>0))
-  {
-    // remove the left area if empty
-    $("#additional_infoID").get(0).parentNode.removeChild($("#additional_infoID").get(0));
-  }
-  $(".additional_info").css("visibility", "visible");
-
-  if($("#additional_infoBOTTOM").attr("innerHTML").replace(/\s*/im, "")=="")
-  {
-    // remove the bottom area if empty
-    $("#additional_infoBOTTOM").get(0).parentNode.removeChild($("#additional_infoBOTTOM").get(0));
-  }
-  else
-  {
-    $("#additional_infoBOTTOM").css("visibility", "visible");
-  }
-
-  if($("#additional_infoTOP").attr("innerHTML").replace(/\s*/im, "")=="")
-  {
-    // remove the top area if empty
-    $("#additional_infoTOP").get(0).parentNode.removeChild($("#additional_infoTOP").get(0));
-  }
-  else
-  {
-    $("#additional_infoTOP").css("visibility", "visible");
-  }
-}
-
-
-function initMenu()
-{
-  if(options.menuAnimated != "noswitch")
-  {
-    $("#menubar").css(
+    }
+    else
+    {
+      switch(force)
       {
-        visibility:"hidden",
-        top: $("#titrePageID").attr("offsetTop")+$("#titrePageID").attr("offsetHeight")-2+'px'
-      }
-    );
-    switchmenu('n');
-    switch(options.menuWidth)
-    {
-      case "auto":
-        $("#menubar").css("width", "auto");
-        maxwidth=options.menuMaxWidth;
-
-        regexp = /[1234567]\./i;
-        if(jQuery.browser.msie && jQuery.browser.version.match(regexp))
-        {
-          maxwidth=options.menuMSIEMaxWidth;
-        }
-        if(maxwidth>0) { $("#menubar").css("max-width", maxwidth+"px"); }
-        break;
-      case "info":
-        $("#menubar").css("width", $(".additionnal_info").css("width"));
-        break;
-      default:
-        $("#menubar").css("width", options.menuWidth+"px");
-    }
-  }
-  else
-  {
-    $("#menubar dl dd").each(
-      function (index, elem)
-      {
-        //alert($(this.parentNode).attr('offsetWidth')+"---"+$(this.parentNode).attr('id'));
-        $(this).css("min-width", $(this.parentNode).attr('offsetWidth'));
-        if(jQuery.browser.msie)
-        {
-          $(this).css("max-width", options.menuMSIEMaxWidth+"px");
-        }
-      }
-    );
-  }
-}
-
-
-function switchmenu(force, iconpath)
-{
-  if(force=='')
-  {
-    (!menuState)?force='y':force='n';
-  }
-
-  if(options.menuAnimated == "fade")
-  {
-    switch(force)
-    {
-      case 'y':
-        $("#menubar").css({
-          visibility:"visible",
-          height:"auto"
-        }).fadeTo(options.animateDelay,1);
-        $("#icon_menu").attr("className", "button2");
-        menuState=true;
-        break;
-      default:
-        $("#menubar").fadeTo(options.animateDelay, 0, function () {
+        case 'y':
+          $("#menubar").css({
+            visibility:"visible",
+            height:"auto"
+          });
+          $("#icon_menu").attr("className", "button2");
+          menuState=true;
+          break;
+        default:
           $("#menubar").css({
             visibility:"hidden",
             height:"0px"
           });
-        });
-        $("#icon_menu").attr("className", "button");
-        menuState=false;
-    }
-  }
-  else
-  {
-    switch(force)
-    {
-      case 'y':
-        $("#menubar").css({
-          visibility:"visible",
-          height:"auto"
-        });
-        $("#icon_menu").attr("className", "button2");
-        menuState=true;
-        break;
-      default:
-        $("#menubar").css({
-          visibility:"hidden",
-          height:"0px"
-        });
-        $("#icon_menu").attr("className", "button");
-        menuState=false;
-    }
-  }
+          $("#icon_menu").attr("className", "button");
+          menuState=false;
+      }
+    }
+  };
+
+  this.switchmenu = function(force, iconpath) { switchmenu(force, iconpath); };
+
+  initMenu();
+  initContentDesc();
 }
+
+
Index: extensions/gally/gally-default/js/gallyjs-tpp.js
===================================================================
--- extensions/gally/gally-default/js/gallyjs-tpp.js	(revision 8191)
+++ extensions/gally/gally-default/js/gallyjs-tpp.js	(revision 8528)
@@ -4,7 +4,7 @@
   ------------------------------------------------------------------------------
   file: gally/gallyjs-tpp.js
-  file release: 1.3.4
+  file release: 1.4.0
   ------------------------------------------------------------------------------
-  author: grum at grum.dnsalias.com
+  author: grum at piwigo.org
   << May the Little SpaceFrog be with you >>
   ------------------------------------------------------------------------------
